/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef __MTK_SATELLITES_H__
#define __MTK_SATELLITES_H__
#include  "../common/math/vector3.h"
#include  "mtk_draw_struct.h"
#include  "mtk_space_curve.h"


//-------------
//  Constants
//-------------
const float R_moon_km = 1738.092;



//-------------
//  Functions
//-------------

//--  Register  --
void	register_object_satellites();

//--  Scale  --
double	get_scale_satellite(int idx);
//--  Label  --
bool	is_satellite_label_visible(int idx);
float	get_satellite_label_alpha(const mtk_draw_struct& ds, int idx);

//--
double	get_landing_radius_satellite(int idx);


//--  Load Textures  --
void	load_satellites_textures();

//--  Text size  --//
void	set_satellites_name_size(float sz);
float	get_satellites_name_size();



//--  Orbits  --
void	register_satellites_orbit_curves();
void	make_satellites_orbit_curve(space_curve& sc, double t, int div_N);
void	set_satellites_orbit_curve(space_curve& sc, double t);
float	get_satellite_orbit_alpha(const mtk_draw_struct& ds, int idx);

//--  select  --
bool	is_satellite_selected(int idx);


//--  Visible radius  --




//--  Draw  --
bool	prepare_draw_satellite(const mtk_draw_struct& ds, int idx, double* pRb, double* pRh);
void	draw_a_satellite(const mtk_draw_struct& ds, int idx, const vector3d& rpos, const double& scl);

//--  Hit-test
bool	hit_test_satellite(const mtk_draw_struct& ds, int idx, const vector3d& rpos, const vector3d& nv);

//--  Info
void	make_object_info_satellite(const mtk_draw_struct& ds, int idx, std::vector<std::string>& text);


//****
void	draw_satellites_planetarium(const mtk_draw_struct& ds);


#endif
